//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/Items/LayerRoughnessItems.h
//! @brief     Defines classes LayerRoughnessItems
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#ifndef BORNAGAIN_GUI_ITEMS_LAYERROUGHNESSITEMS_H
#define BORNAGAIN_GUI_ITEMS_LAYERROUGHNESSITEMS_H

#include "GUI/Items/SessionItem.h"

class DoubleDescriptor;

class LayerZeroRoughnessItem : public SessionItem {
public:
    static constexpr auto M_TYPE{"LayerZeroRoughness"};

    LayerZeroRoughnessItem();
};

class LayerBasicRoughnessItem : public SessionItem {
private:
    static constexpr auto P_SIGMA{"Sigma"};
    static constexpr auto P_HURST{"Hurst"};
    static constexpr auto P_LATERAL_CORR_LENGTH{"CorrelationLength"};

public:
    static constexpr auto M_TYPE{"LayerBasicRoughness"};

    LayerBasicRoughnessItem();

    DoubleDescriptor sigma() const;
    DoubleDescriptor hurst() const;
    DoubleDescriptor lateralCorrelationLength() const;
};

#endif // BORNAGAIN_GUI_ITEMS_LAYERROUGHNESSITEMS_H
