//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/Items/TransformationItem.h
//! @brief     Defines class TransformationItem
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#ifndef BORNAGAIN_GUI_ITEMS_TRANSFORMATIONITEM_H
#define BORNAGAIN_GUI_ITEMS_TRANSFORMATIONITEM_H

#include "GUI/Items/SessionGraphicsItem.h"

class RotationItem;

class BA_CORE_API_ TransformationItem : public SessionGraphicsItem {
private:
    static constexpr auto P_ROT{"Rotation type"};

public:
    static constexpr auto M_TYPE{"Rotation"};

    TransformationItem();

    RotationItem* rotationItem() const;
    template <typename T> T* setRotationType();
    void setRotationType(const QString& modelType);
};


template <typename T> T* TransformationItem::setRotationType()
{
    static_assert(std::is_base_of<RotationItem, T>::value,
                  "Class must be derived from RotationItem");

    return setGroupPropertyType<T>(P_ROT);
}

#endif // BORNAGAIN_GUI_ITEMS_TRANSFORMATIONITEM_H
