//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/Views/InstrumentWidgets/DepthProbeInstrumentEditor.h
//! @brief     Defines class DepthProbeInstrumentEditor
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#ifndef BORNAGAIN_GUI_VIEWS_INSTRUMENTWIDGETS_DEPTHPROBEINSTRUMENTEDITOR_H
#define BORNAGAIN_GUI_VIEWS_INSTRUMENTWIDGETS_DEPTHPROBEINSTRUMENTEDITOR_H

#include <QWidget>

class DepthProbeInstrumentItem;
class DistributionEditor;
class InclinationAnglesEditor;
class SphericalAxisEditor;
class PolarizationAnalysisEditor;

class DepthProbeInstrumentEditor : public QWidget {
    Q_OBJECT

public:
    DepthProbeInstrumentEditor(QWidget* parent = nullptr, Qt::WindowFlags f = Qt::WindowFlags());
    void setItem(DepthProbeInstrumentItem* item);

private:
    DistributionEditor* m_wavelengthEditor;
    InclinationAnglesEditor* m_inclinationEditor;
    SphericalAxisEditor* m_depthAxisEditor;
    PolarizationAnalysisEditor* m_polpairAnalysisEditor;
};

#endif // BORNAGAIN_GUI_VIEWS_INSTRUMENTWIDGETS_DEPTHPROBEINSTRUMENTEDITOR_H
