//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/Views/InstrumentWidgets/EditDistributionDialog.h
//! @brief     Defines class EditDistributionDialog
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#ifndef BORNAGAIN_GUI_VIEWS_INSTRUMENTWIDGETS_EDITDISTRIBUTIONDIALOG_H
#define BORNAGAIN_GUI_VIEWS_INSTRUMENTWIDGETS_EDITDISTRIBUTIONDIALOG_H

#include "GUI/Views/InstrumentWidgets/DistributionEditor.h"

#include <QDialog>
class DistributionPlot;
class DistributionSelector;
class ItemWithDistribution;


//! The dialog which shows an editor to change parameters of DistributionItem
class EditDistributionDialog : public QDialog {
    Q_OBJECT

public:
    EditDistributionDialog(ItemWithDistribution* item, const QString& title,
                           const std::optional<MeanConfig>& mean_config,
                           Distributions distributions, QWidget* parent = nullptr,
                           Qt::WindowFlags f = Qt::WindowFlags());

private slots:
    void updatePlot();

private:
    DistributionPlot* m_plot;
    DistributionSelector* m_selector;
    ItemWithDistribution* m_item;
};

#endif // BORNAGAIN_GUI_VIEWS_INSTRUMENTWIDGETS_EDITDISTRIBUTIONDIALOG_H
