//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/Views/InstrumentWidgets/EnvironmentEditor.h
//! @brief     Defines class EnvironmentEditor
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#ifndef BORNAGAIN_GUI_VIEWS_INSTRUMENTWIDGETS_ENVIRONMENTEDITOR_H
#define BORNAGAIN_GUI_VIEWS_INSTRUMENTWIDGETS_ENVIRONMENTEDITOR_H

#include <QWidget>

class ConstantBackgroundForm;
class InstrumentItem;
class QComboBox;
class QStackedLayout;

//! Environment editor (i.e. background) for instrument editors.
//! Operates on InstrumentItem.

class EnvironmentEditor : public QWidget {
    Q_OBJECT

public:
    EnvironmentEditor(QWidget* parent = nullptr, Qt::WindowFlags f = Qt::WindowFlags());
    void setItem(InstrumentItem* item);

private slots:
    void onBackgroundSelected(int index);

private:
    QStackedLayout* m_stack;
    QComboBox* m_combo;
    QWidget* m_blankForm;
    ConstantBackgroundForm* m_constBgForm;
    InstrumentItem* m_item;
};

#endif // BORNAGAIN_GUI_VIEWS_INSTRUMENTWIDGETS_ENVIRONMENTEDITOR_H
