//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/Views/SampleDesigner/InterferenceViews.cpp
//! @brief     Implements classes InterferenceViews
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#include "GUI/Views/SampleDesigner/InterferenceViews.h"
#include "GUI/CommonWidgets/DesignerHelper.h"

Interference1DLatticeView::Interference1DLatticeView(QGraphicsItem* parent)
    : ConnectableView(parent)
{
    setColor(QColor(255, 236, 139));
    setRectangle(DesignerHelper::getInterferenceBoundingRect());
    addPort("out", NodeEditorPort::OUTPUT, NodeEditorPort::INTERFERENCE);
    m_roundpar = 3;
}

Interference2DLatticeView::Interference2DLatticeView(QGraphicsItem* parent)
    : ConnectableView(parent)
{
    setColor(QColor(255, 236, 139));
    setRectangle(DesignerHelper::getInterferenceBoundingRect());
    addPort("out", NodeEditorPort::OUTPUT, NodeEditorPort::INTERFERENCE);
    m_roundpar = 3;
}

Interference2DParaCrystalView::Interference2DParaCrystalView(QGraphicsItem* parent)
    : ConnectableView(parent)
{
    setColor(QColor(255, 236, 139));
    setRectangle(DesignerHelper::getInterferenceBoundingRect());
    addPort("out", NodeEditorPort::OUTPUT, NodeEditorPort::INTERFERENCE);
    m_roundpar = 3;
}

InterferenceFinite2DLatticeView::InterferenceFinite2DLatticeView(QGraphicsItem* parent)
    : ConnectableView(parent)
{
    setColor(QColor(255, 236, 139));
    setRectangle(DesignerHelper::getInterferenceBoundingRect());
    addPort("out", NodeEditorPort::OUTPUT, NodeEditorPort::INTERFERENCE);
    m_roundpar = 3;
}

InterferenceHardDiskView::InterferenceHardDiskView(QGraphicsItem* parent) : ConnectableView(parent)
{
    setColor(QColor(255, 236, 139));
    setRectangle(DesignerHelper::getInterferenceBoundingRect());
    addPort("out", NodeEditorPort::OUTPUT, NodeEditorPort::INTERFERENCE);
    m_roundpar = 3;
}

InterferenceRadialParaCrystalView::InterferenceRadialParaCrystalView(QGraphicsItem* parent)
    : ConnectableView(parent)
{
    setColor(QColor(255, 236, 139));
    setRectangle(DesignerHelper::getInterferenceBoundingRect());
    addPort("out", NodeEditorPort::OUTPUT, NodeEditorPort::INTERFERENCE);
    m_roundpar = 3;
}
