//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/Views/SampleDesigner/InterferenceViews.h
//! @brief     Defines classes InterferenceViews
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#ifndef BORNAGAIN_GUI_VIEWS_SAMPLEDESIGNER_INTERFERENCEVIEWS_H
#define BORNAGAIN_GUI_VIEWS_SAMPLEDESIGNER_INTERFERENCEVIEWS_H

#include "GUI/Views/SampleDesigner/ConnectableView.h"

class Interference1DLatticeView : public ConnectableView {
    Q_OBJECT
public:
    Interference1DLatticeView(QGraphicsItem* parent = nullptr);
    int type() const override { return GUI::View::Types::INTERFERENCE_FUNCTION_1D_LATTICE; }
};

class Interference2DLatticeView : public ConnectableView {
    Q_OBJECT
public:
    Interference2DLatticeView(QGraphicsItem* parent = nullptr);
    int type() const override { return GUI::View::Types::INTERFERENCE_FUNCTION_2D_LATTICE; }
};

class Interference2DParaCrystalView : public ConnectableView {
    Q_OBJECT
public:
    Interference2DParaCrystalView(QGraphicsItem* parent = nullptr);
    int type() const override { return GUI::View::Types::INTERFERENCE_FUNCTION_2D_PARA; }
};

class InterferenceFinite2DLatticeView : public ConnectableView {
    Q_OBJECT
public:
    InterferenceFinite2DLatticeView(QGraphicsItem* parent = nullptr);
    int type() const override { return GUI::View::Types::INTERFERENCE_FUNCTION_FINITE_2D_LATTICE; }
};

class InterferenceHardDiskView : public ConnectableView {
    Q_OBJECT
public:
    InterferenceHardDiskView(QGraphicsItem* parent = nullptr);
    int type() const override { return GUI::View::Types::INTERFERENCE_FUNCTION_HARD_DISK; }
};

class InterferenceRadialParaCrystalView : public ConnectableView {
    Q_OBJECT
public:
    InterferenceRadialParaCrystalView(QGraphicsItem* parent = nullptr);
    int type() const override { return GUI::View::Types::INTERFERENCE_FUNCTION_RADIAL_PARA; }
};

#endif // BORNAGAIN_GUI_VIEWS_SAMPLEDESIGNER_INTERFERENCEVIEWS_H
