//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/Views/SampleDesigner/ParticleForm.h
//! @brief     Defines class ParticleForm
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2021
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#ifndef BORNAGAIN_GUI_VIEWS_SAMPLEDESIGNER_PARTICLEFORM_H
#define BORNAGAIN_GUI_VIEWS_SAMPLEDESIGNER_PARTICLEFORM_H

#include <QGroupBox>

class ParticleItem;
class QAction;
class SampleEditorController;

//! Form for editing a particle
class ParticleForm : public QGroupBox {
    Q_OBJECT
public:
    ParticleForm(QWidget* parent, ParticleItem* item, SampleEditorController* ec,
                 bool allowRemove = true);
    void enableStructureEditing(bool b);

private:
    QAction* m_removeAction = nullptr;
};


#endif // BORNAGAIN_GUI_VIEWS_SAMPLEDESIGNER_PARTICLEFORM_H
