//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/utils/GUIHelpers.h
//! @brief     Defines class GUIHelpers functions
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#ifndef BORNAGAIN_GUI_UTILS_GUIHELPERS_H
#define BORNAGAIN_GUI_UTILS_GUIHELPERS_H

#include <QWidget>

class RealLimits;
class QDoubleSpinBox;
class QLineEdit;

namespace GUI::View::Helpers {

void information(QWidget* parent, const QString& title, const QString& text,
                 const QString& detailedText = "");

void warning(QWidget* parent, const QString& title, const QString& text,
             const QString& detailedText = "");

bool question(QWidget* parent, const QString& title, const QString& text,
              const QString& detailedText = "", const QString& yesText = "&Yes",
              const QString& noText = "&No");

bool okToDelete(QWidget* parent, const QString& title, const QString& text,
                const QString& detailedText = "");

QString readTextFile(const QString& fileName);

void configScientificDoubleEdit(QLineEdit* edit, const RealLimits& limits);

void configSpinbox(QDoubleSpinBox* spinBox, int decimals, const RealLimits& limits);


} // namespace GUI::View::Helpers

#endif // BORNAGAIN_GUI_UTILS_GUIHELPERS_H
