//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/utils/SaveLoadInterface.cpp
//! @brief     Impelments save/load interface.
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#include "GUI/utils/SaveLoadInterface.h"
#include "Base/Utils/FileSystemUtils.h"

QString SaveLoadInterface::fileName(const QString& projectDir) const
{
    return QString::fromStdString(
        BaseUtils::Filesystem::jointPath(projectDir.toStdString(), fileName().toStdString()));
}
