#include "GUI/Items/LayerItem.h"
#include "GUI/Items/MaterialItem.h"
#include "GUI/Models/Data/ApplicationModels.h"
#include "GUI/Models/Material/MaterialModel.h"
#include "GUI/Models/Sample/SampleModel.h"
#include "Tests/GTestWrapper/google_test.h"

class TestLayerItems : public ::testing::Test {
};

//! Checking default material of the layer.

TEST_F(TestLayerItems, test_LayerDefaultMaterial)
{
    ApplicationModels models;
    auto layer = models.sampleModel()->insertItem<LayerItem>();
    auto materials = models.materialModel()->topItems<MaterialItem>();
    auto defMaterial = materials.front();

    EXPECT_EQ(layer->materialName(), "Default");
    EXPECT_EQ(layer->materialIdentifier(), defMaterial->identifier());
}
