#include "GUI/Items/LayerItem.h"
#include "GUI/Items/MultiLayerItem.h"
#include "GUI/Items/ParticleCompositionItem.h"
#include "GUI/Items/ParticleItem.h"
#include "GUI/Items/ParticleLayoutItem.h"
#include "GUI/Items/SessionItemUtils.h"
#include "GUI/Items/SimulationOptionsItem.h"
#include "GUI/Models/Data/DocumentModel.h"
#include "GUI/Models/Group/ComboProperty.h"
#include "GUI/Models/Sample/SampleModel.h"
#include "Tests/GTestWrapper/google_test.h"
#include <QtTest>

class TestMapperCases : public ::testing::Test {
};

TEST_F(TestMapperCases, test_ParticeleCompositionUpdate)
{
    SampleModel model;
    auto multilayer = model.insertItem<MultiLayerItem>();
    auto layer = model.insertItem<LayerItem>(multilayer);
    auto layout = model.insertItem<ParticleLayoutItem>(layer);

    // composition added to layout should have abundance enabled
    auto compositionFree = model.insertItem<ParticleCompositionItem>(layout);
    EXPECT_TRUE(compositionFree->abundanceItem()->isEnabled());
}
